from random import randint
import os
from time import sleep


def dico_n_lettres(dico):
  #fonction qui crée une fois pour toute des dictionnaires
  #de mots avec un nombre donné de lettres à partir d un
  #fichier texte
  for n in range(5, 11):
    path = os.getcwd() + '/'  # définit le répertoire ou se trouve le ditionnaire
    dico1 = path + dico + ".txt"  # fichier contenant le dictionnaire
    dico2 = path + dico + str(n) + ".txt"  # fichier qui contiendra le dictionnaire des mots à n lettres
    fichier1 = open(dico1, "r")
    fichier2 = open(dico2, "w")
    for mot in fichier1:
      if len(mot) == n + 1:  # n+1 car on doit tenir compte du caractère de retour à la ligne
        fichier2.write(mot)
    fichier1.close()
    fichier2.close()
  return


def choisir_un_mot(dico, n):
  #fonction qui va choisir aléatoirement un mot
  #de n lettres
  path = os.getcwd() + '/'
  dicob = path + dico + str(n) + ".txt"
  fichier = open(dicob, "r")
  liste_mots = fichier.readlines()  # met tous les mots du fichiers dans une liste
  i = randint(1, len(liste_mots))
  mot = liste_mots[i]  # prend au hasard un mot dans la liste
  mot = mot.replace('\n', '')  # supprime le caractère de retour à la ligne
  fichier.close()
  return (mot)


def teste_mot(liste, lettre, dico, n):
  # Teste si le mot proposé par le joueur
  # est valide : il doit commencer par 'lettre'
  # se trouver dans dico et être de n lettres.
  test = True
  mot = ''.join(
    liste).lower()  #transforme 'liste' en chaine de caractère en minuscule
  path = os.getcwd() + '/'
  dico = path + dico + str(n) + ".txt"
  fichier = open(dico, "r")
  liste1 = fichier.readlines()  # met tous les mots du dico dans une liste
  liste_mots = []
  for mot1 in liste1:
    liste_mots.append(mot1.replace('\n', ''))
  if len(liste) != n:  # teste si le mot est de la bonne longueur
    test = False
    print('Ce mot n est pas de la bonne longueur.\n')
  elif (mot not in liste_mots):  # teste si le mot est dans le dico
    test = False
    print('Ce mot n est pas dans le dictionnaire.\n')
  elif liste[0] != lettre:  # teste si le mot commence par la bonne lettre
    test = False
    print('Ce mot ne commence pas par la lettre ' + lettre,'\n')
  else:
    test = True
  fichier.close()
  return (test)


def lettres_communes(liste1, liste2):
  # Retourne une liste avec toutes les lettres
  # de la liste1 se trouvant dans la liste2
  # les lettres bien placées sont en majuscule
  # les autres sont en minuscule.
  liste = []
  liste3 = []
  for i in range(len(liste1)):
    liste.append("")
    liste3.append(liste2[i])
  for i in range(len(liste1)):
    if liste1[i] == liste3[i]:
      liste[i] = liste1[i].upper()
      liste3[i] = ''
  for i in range(len(liste1)):
    for j in range(len(liste1)):
      if liste1[i] == liste3[j] and liste[i] == '':
        liste[i] = liste1[i].lower()
        liste3[j] = ''
        break
  return (liste)

def lettres_placees(liste1,liste2,liste3):
# fonction qui met dans liste1 les lettres 
# communes bien placées des liste2 et liste3
    liste = []
    liste0 = []
    for i in range(len(liste2)):
        if liste2[i]==liste3[i]:
            liste0.append(liste2[i])
        else:
            liste0.append("")
    for i in range(len(liste1)):
        if liste1[i]==liste0[i]:
            liste.append(liste1[i])
        else:
            liste.append(liste1[i]+liste0[i])
    return(liste)


def affiche_mot(liste):
  # Transforme en chaine caractère 'liste' en remplacant
  # les éléments "" par le caractère "_" et affiche la chaine
  mot = ""
  for i in liste:
    if i == "":
      mot = mot + "_ "
    else:
      mot = mot + i + " "
  return (mot)


def echange_joueur(joueur, joueur1, joueur2):
  #   Effectue le changement de joueur dans une partie à 2
  if joueur == joueur1:
    joueur = joueur2
  else:
    joueur = joueur1
  return (joueur)


def lettre_bonus(liste1, liste2):
  # affecte à la première "case" vide de lettre 1
  # la lettre correspondante du mot contenu dans liste2
  # ex: si liste1=['L','','','T','E'] et liste2=['L','I','S','T','E']
  # renvoie liste1=['L','I','','T','E']
  for i in range(len(liste1)):
    if liste1[i] == '':
      liste1[i] = liste2[i]
      break
  return (liste1)


def MOTUS_2joueurs(dico):
  # lance le jeu MOTUS en mode 2 joueurs
  n = 0
  nb_essais_max = 6
  test = True
  score1 = 0
  score2 = 0
  partie = 0
  joueur1 = str(input('Joueur 1 entrez votre nom :\n'))
  joueur2 = str(input('Joueur 2 entrez votre nom :\n'))
  joueur = joueur1
  while (n < 5) or (n > 10):
    n = int(input('Choisissez un nombre de lettres entre 5 et 10 \n'))
  print('Vous cherchez un mot de', n, 'lettres et vous avez', nb_essais_max,'essais.\n')
  nb_parties = int(input('Sur combien de parties voulez-vous vous affronter ?\n'))
  while partie < nb_parties:
    nb_essais = 0
    partie = partie + 1
    lettres_plac = []
    mot_mystere = choisir_un_mot('dico', n)  # choisis aléatoirement le mot mystère dans le dico
    liste_mot_mystere = list(mot_mystere.upper())  # transforme ce mot en liste
    for i in range(n):
      if i == 0:
        lettres_plac.append(liste_mot_mystere[0])  # initialise la liste des lettres bien placées
      else:  # avec la 1re lettre du mot mystère et des ''
        lettres_plac.append('')
    print('Partie ' + str(partie) + '. ' + joueur + ' à vous de commencer.\n')  # indique le numéro de la partie et le joueur qui commence
    print(joueur + ' ', nb_essais_max - nb_essais, affiche_mot(lettres_plac))
    while (nb_essais < nb_essais_max):
      mot_joue = str(input(''))  # variable qui contient le mot saisi par le joueur
      liste_mot_joue = list(mot_joue.upper())
      if (liste_mot_joue == liste_mot_mystere):  # si mot saisi = mot à deviner, affiche message victorieux
        print('Vous avez gagné en', nb_essais,'essais\n')  # et le nb d'essais effectués pour trouver le mot
        if joueur == joueur1:  # mise à jour du score
          score1 = score1 + 1
        else:
          score2 = score2 + 1
        break
      test = teste_mot(liste_mot_joue, liste_mot_mystere[0], dico,n)  # teste si le mot joué est valide
      if test == True:                                                # si le mot joué est valide
        lettres_com = lettres_communes(liste_mot_joue, liste_mot_mystere)  # met à jour les lettres communes
        print((len(joueur) + 3) * ' ',affiche_mot(lettres_com))  # puis les affiche
        lettres_plac = lettres_placees(lettres_plac, liste_mot_joue,liste_mot_mystere)  # met à jour les lettres bien placées
      else:
        joueur = echange_joueur(joueur, joueur1,joueur2)              # si le mot n'est pas valide, change de joueur
        lettres_plac = lettre_bonus(lettres_plac, liste_mot_mystere)  # et donne une lettre bonus
      nb_essais = nb_essais + 1
      print(joueur + ' ', nb_essais_max - nb_essais, affiche_mot(lettres_plac))
      if (nb_essais == nb_essais_max):
        print('Vous avez perdu ! Le mot à deviner était : ',mot_mystere.upper(), '\n')  # si échec, révèle le mot à deviner
        joueur = echange_joueur(joueur, joueur1,joueur2)  # et change de joueur pour la partie suivante
    if partie == nb_parties:  # au terme des parties affiche les scores
      if score1 > score2:
        print('Félicitations ' + joueur1 + ', vous avez gagné ! score : ',score1, '-', score2, '\n')
      elif score1 < score2:
        print('Félicitations ' + joueur2 + ', vous avez gagné ! score : ',score2, '-', score1, '\n')
      else:
        print('Vous avez fait match nul :', score1, '-', score2, '\n')



def jeu1joueur(dico):
    teste=False
    m=int(input("Choisisez le nombre de lettres du mot:\n"))
    while teste==False:
        if m>20:
            print("Le nombre de lettres ne peut pas être supérieur à 10")
            teste=False
        elif 4>m:
            teste=False
            print("Le nombre de lettres ne peut pas être infèrieur à 5")
        else:
            teste=True
            print("difficulté:", m ,"lettres")
    liste4=[]
    mot_mystere=choisir_un_mot(dico,m).upper()
    liste2=list(mot_mystere)
    liste1=[liste2[0]]
    for i in range(int(m)-1):#créer la liste1 avec les trous et la majuscule +car si on rentre 3 le mot choisis sera de 4 lettres et non de 3
      liste1.append("")
    liste1[0]=liste1[0].upper()
    print("Mot à trouver:",affiche_mot(liste1))
    print("Votre réponse:")
    for i in range(6):#6 essais
      reponse=input()
      liste3=list(reponse.upper())
      test=False
      while teste_mot(liste3,liste1[0],dico,m)==False: #boucle infini juqu'a que le mot soit considérée comme valide
        print("Votre nouvelle réponse:")
        reponse=input()
        liste3=list(reponse.upper())
      if liste2==liste3:
          print("Bravo ! Vous avez gagné (•̀ᴗ•́)و ̑̑")
          break
      liste4=lettres_communes(liste3,liste2)
      liste1 = lettres_placees(liste1,liste3,liste2)  
      if (i!=5):
        print("\nLes lettres communes sont: ")
        print(' ', affiche_mot(liste4))
        print("\nMot à trouver:", affiche_mot(liste1))
        print("Il vous reste",5-i,"essais")
      if (i==5): 
        print('Vous avez perdu ! Le mot à deviner était : ',mot_mystere.upper(),'\n')


#DEBUT DU PROGRAMME PRINCIPAL
print("Bienvenue dans le jeu du MOTUS fait par Elyes.T et Raphael.C\n")
sleep(1)
choix=0
while (choix!=1) and (choix!=2):
      choix=int(input('Si vous voulez jouer avec des verbes conjugués tapez 1 sinon tapez 2 :\n'))
      if choix==1:
          dico="dico"
      else:
          dico="littre"
if not os.path.exists(dico +"5.txt") or not os.path.exists(dico+"6.txt") or not os.path.exists(dico+"7.txt") \
   or not os.path.exists(dico+"8.txt") or not os.path.exists(dico+"9.txt") or not os.path.exists(dico+"10.txt"):
      dico_n_lettres(dico)
print("Tapez 1 pour le mode 1 joueur ou tapez 2 pour le mode duel")
m=int(input())
teste=0
compteur=0
while teste==False:
    if m==1:
        teste=True
        print("Vous avez choisi le mode 1 joueur\n")
        sleep(.5)
        jeu1joueur(dico)
    elif m==2:
        teste=True
        print("Vous avez choisi le mode duel\n")
        sleep(.5)
        MOTUS_2joueurs(dico)
    elif compteur==4:
        teste=True
        print("\nLe mode 1 joueur a été choisi par défaut\n")
        sleep(.5)
        jeu1joueur()
    else:
        teste=False
        compteur+=1
        print("Erreur: vous n'avez pas choisi le mode de jeu\n")
        sleep(.5)
        print("Tapez 1 pour le mode 1 joueur ou tapez 2 pour le mode duel")
        m=int(input())
        
        